<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta2/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-BmbxuPwQa2lc/FVzBcNJ7UAyJxM6wuqIj61tLrc4wSX0szH/Ev+nYRRuWlolflfl" crossorigin="anonymous">
</head>
<body>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-b5kHyXgcpbZJO/tY9Ul7kGkf1S0CWuKcCD38l8YkeH8z8QjE0GmW1gYU5S9FOnJ0"
        crossorigin="anonymous">
</script>
<script type='text/javascript' src="/js/listen-to-stream.js"></script>

<div class="container">
    <form method="post" action="/items/new">
        <div class="mb-3">
            <label for="item-name-input" class="form-label">Item Name *</label>
            <input type="text" class="form-control" id="item-name-input" name="item-name" required>
        </div>
        <div class="mb-3">
            <label for="item-price-input" class="form-label">Item Price *</label>
            <input type="number"
                   class="form-control"
                   id="item-price-input"
                   name="item-price"
                   placeholder="Please, wait until we fetch the preferred currency…"
                   required
                   disabled>
        </div>
        <div class="mb-3">
            <select class="form-select"
                    id="item-currency-select"
                    name="item-currency"
                    onchange="updateControls()">
                <option disabled selected hidden>Currency</option>
            </select>
        </div>
        <button class="btn btn-primary">Submit</button>
    </form>
</div>

<script type="text/javascript">
    var preferredCurrency = null

    function updateControls() {
        if (preferredCurrency === null) {
            return
        }

        const itemCurrencySelect = document.getElementById("item-currency-select")
        const options = itemCurrencySelect.options

        let preferredIndex = -1
        for (let i = 0; i < options.length; ++i) {
            if (options[i].text == preferredCurrency) {
                preferredIndex = i
                break
            }
        }

        if (itemCurrencySelect.selectedIndex === 0) { // user hasn't chosen anything but default
            if (preferredIndex === -1) {
                return
            }
            itemCurrencySelect.selectedIndex = preferredIndex
        } else {
            preferredIndex = itemCurrencySelect.selectedIndex
        }

        const itemPriceInput = document.getElementById("item-price-input")
        itemPriceInput.placeholder = "Type the item price in " + options[preferredIndex].text
        itemPriceInput.disabled = false
    }

    listenToStream("preferred-currency", function (event) {
        const currencyName = JSON.parse(event.data)
        preferredCurrency = currencyName
        updateControls()
    })

    listenToStream("currencies", function (event) {
        const currencyName = JSON.parse(event.data)
        const itemCurrencySelect = document.getElementById("item-currency-select")
        const newOption = document.createElement("option")
        newOption.text = currencyName
        itemCurrencySelect.add(newOption)
        updateControls()
    })
</script>

</body>
</html>